=== debian/changelog ===
hsflowd (2.0.30-1-cl4.3.1u4) RELEASED; urgency=medium

  * new build for 4.3.1 from original hash
    7992ccbd98c3f8fcf4b0dc6108dff4bb78b9f431

 -- root <root@3da22e72fb7c>  Tue, 14 Jun 2022 19:41:33 +0000

hsflowd (2.0.30-1-cl4.3.0u1) RELEASED; urgency=medium

  * bumb version for CL 4.3.0

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 09 Dec 2020 18:50:52 +0000

hsflowd (2.0.30-1-cl4.2.1u2) RELEASED; urgency=high

  * start hsflowd.service in default vrf

 -- dev-support <dev-support@cumulusnetworks.com>  Thu, 29 Oct 2020 20:19:07 -0700

hsflowd (2.0.30-1-cl4.2.1u1) UNRELEASED; urgency=high

  * upgrade to upstream hsflowd v2.0.30-1

 -- dev-support <dev-support@cumulusnetworks.com>  Tue, 18 Aug 2020 19:22:49 +0000

hsflowd (2.0.11-cl4u1) RELEASED; urgency=medium

  [ Elizabeth Seamans ]
  * 4.0 support: libssl added for sha.h

  [ Neil McKee ]
  * Added mod_psample, to read packet samples from generic netlink PSAMPLE channel.
  * mod_psample In/Out direction requires HSP_SAMPLEOPT_BRIDGE flag.

 -- dev-support <dev-support@cumulusnetworks.com>  Thu, 18 Apr 2019 14:22:52 -0700

hsflowd (2.0.11-cl3u7) RELEASED; urgency=medium

  * Closes CM-19301: change max sampling rate to support 100G ports

 -- dev-support <dev-support@cumulusnetworks.com>  Mon, 25 Jun 2018 09:20:58 -0700

hsflowd (2.0.11-cl3u6) RELEASED; urgency=medium

  * Closes CM-17695: update hsflowd to 2.0

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 08 Nov 2017 14:16:28 -0800

hsflowd (1.29.3-cl3u5) RELEASED; urgency=medium

  * Closes: CM-12654. Default nflog group not set.

 -- dev-support <dev-support@cumulusnetworks.com>  Fri, 02 Dec 2016 09:39:44 -0800

hsflowd (1.29.3-cl3u4) RELEASED; urgency=medium

  * Closes CM-12108: hsflowd should not be enabled automatically
  * Closes CM-11809: Fix for hsflowd ing rate set values not reapplied after switchd restart
  * Closes CM-11706: Fix signal 11 crash on switchd restart

 -- dev-support <dev-support@cumulusnetworks.com>  Thu, 11 Aug 2016 10:48:58 -0700

hsflowd (1.29.3-cl3u3) RELEASED; urgency=low

  * CumulusLinux 3 initial release.

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 27 Apr 2016 16:07:30 -0700
