=== debian/control ===
Source: hsflowd
Maintainer: dev-support <dev-support@cumulusnetworks.com>
Section: admin
Priority: optional
Build-Depends: debhelper, libnfnetlink-dev, libdbus-1-dev, libssl-dev
XS-Build-Source: True
XS-Cumulus-Valid-Arch: amd64 armel
XBCS-Vcs-Hash: 7992ccbd98c3f8fcf4b0dc6108dff4bb78b9f431

Package: hsflowd
Architecture: any
Essential: no
Description: sFlow(R) monitoring agent
Homepage: host-sflow.sourceforge.net
XBCS-Vcs-Hash: 7992ccbd98c3f8fcf4b0dc6108dff4bb78b9f431
