=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
%:
	dh $@ --with systemd

DEB_HSFLOWD=$$(pwd)/debian/hsflowd
override_dh_auto_build:
	dh_auto_build -- CUMULUS=yes FEATURES=CUMULUS
override_dh_auto_install:
	mkdir -p $(DEB_HSFLOWD)/usr/sbin
	mkdir -p $(DEB_HSFLOWD)/etc/hsflowd/modules
	cp src/Linux/hsflowd $(DEB_HSFLOWD)/usr/sbin
	cp src/Linux/scripts/hsflowd.conf.cumulus $(DEB_HSFLOWD)/etc/hsflowd.conf
	cp src/Linux/*.so $(DEB_HSFLOWD)/etc/hsflowd/modules/.

override_dh_systemd_enable:
	dh_systemd_enable --no-enable --name=hsflowd hsflowd.service
